'use strict';

exports.__esModule = true;
exports.FormField = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _field = require('./field');

var _formContext = require('./form-context');

var _fieldProps = require('./field-props');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormField = function (_React$Component) {
  (0, _inherits3.default)(FormField, _React$Component);

  function FormField(props, context) {
    (0, _classCallCheck3.default)(this, FormField);

    var _this = (0, _possibleConstructorReturn3.default)(this, _React$Component.call(this, props, context));

    _this.formError = false;

    _this.onInit = function () {
      return _this.__onInit__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onFocus = function () {
      return _this.__onFocus__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onBlur = function () {
      return _this.__onBlur__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onChange = function () {
      return _this.__onChange__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onUpdate = function () {
      return _this.__onUpdate__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onAsyncValid = function () {
      return _this.__onAsyncValid__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onRemove = function () {
      return _this.__onRemove__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.removed = false;
    _this.state = { errorValidators: [] };
    return _this;
  }

  FormField.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this.subscriberId = this.context.form.validators.subscribe(function (error) {
      if (_this2.formError !== error) {
        _this2.formError = error;
        _this2.onValid(_this2.context.form.fields.getFieldByName(_this2.props.name));
      }
    }, this.props.name);
  };

  FormField.prototype.componentWillUnmount = function componentWillUnmount() {
    this.context.form.validators.removeSubscriber(this.subscriberId);
    this.subscriberId = null;
  };

  FormField.prototype.__onInit__REACT_HOT_LOADER__ = function __onInit__REACT_HOT_LOADER__(field) {
    this.context.form.onInitField(field);
    this.onValid(field);
  };

  FormField.prototype.__onFocus__REACT_HOT_LOADER__ = function __onFocus__REACT_HOT_LOADER__(field, e) {
    this.context.form.onUpdateField(field);
    var _props$onFocus = this.props.onFocus,
        onFocus = _props$onFocus === undefined ? function () {} : _props$onFocus;

    onFocus(e, field);
    this.onValid(field);
  };

  FormField.prototype.__onBlur__REACT_HOT_LOADER__ = function __onBlur__REACT_HOT_LOADER__(field, e) {
    this.context.form.onUpdateField(field);
    var _props$onBlur = this.props.onBlur,
        onBlur = _props$onBlur === undefined ? function () {} : _props$onBlur;

    onBlur(e, field);
    this.onValid(field);
  };

  FormField.prototype.__onChange__REACT_HOT_LOADER__ = function __onChange__REACT_HOT_LOADER__(field, e) {
    this.context.form.onUpdateField(field);
    var _props$onChange = this.props.onChange,
        onChange = _props$onChange === undefined ? function () {} : _props$onChange;

    onChange(e, field);
    this.onValid(field);
  };

  FormField.prototype.__onUpdate__REACT_HOT_LOADER__ = function __onUpdate__REACT_HOT_LOADER__(field) {
    this.context.form.onUpdateField(field);
    this.onValid(field);
  };

  FormField.prototype.__onAsyncValid__REACT_HOT_LOADER__ = function __onAsyncValid__REACT_HOT_LOADER__(field) {
    if (!this.removed) {
      this.context.form.onUpdateField(field);
      this.onValid(field);
    }
  };

  FormField.prototype.__onRemove__REACT_HOT_LOADER__ = function __onRemove__REACT_HOT_LOADER__(field) {
    this.removed = true;
    this.context.form.onRemoveField(field);
  };

  FormField.prototype.onValid = function onValid(field) {
    var _props$onValid = this.props.onValid,
        onValid = _props$onValid === undefined ? function () {} : _props$onValid;

    onValid(field.getFieldOptions(), this.formError);
  };

  FormField.prototype.render = function render() {
    var _context$form = this.context.form,
        formValidators = _context$form.formValidators,
        formValidatorsOptions = _context$form.formValidatorsOptions,
        formAsyncValidator = _context$form.formAsyncValidator,
        formAsyncValidatorOptions = _context$form.formAsyncValidatorOptions;
    var _props = this.props,
        name = _props.name,
        _props$validators = _props.validators,
        validators = _props$validators === undefined ? [] : _props$validators,
        _props$validatorsOpti = _props.validatorsOptions,
        validatorsOptions = _props$validatorsOpti === undefined ? {} : _props$validatorsOpti,
        asyncValidator = _props.asyncValidator,
        _props$asyncValidator = _props.asyncValidatorOptions,
        asyncValidatorOptions = _props$asyncValidator === undefined ? {} : _props$asyncValidator,
        other = (0, _objectWithoutProperties3.default)(_props, ['name', 'validators', 'validatorsOptions', 'asyncValidator', 'asyncValidatorOptions']);

    return _react2.default.createElement(_field.Field, (0, _extends3.default)({}, other, {
      name: name,
      validators: [].concat(validators, formValidators[name] || [], this.state.errorValidators),
      validatorsOptions: (0, _extends3.default)({}, formValidatorsOptions[name] || {}, validatorsOptions),
      asyncValidator: asyncValidator || formAsyncValidator[name],
      asyncValidatorOptions: (0, _extends3.default)({}, formAsyncValidatorOptions[name] || {}, asyncValidatorOptions),
      onInit: this.onInit,
      onChange: this.onChange,
      onFocus: this.onFocus,
      onBlur: this.onBlur,
      onUpdate: this.onUpdate,
      onAsyncValid: this.onAsyncValid,
      onRemove: this.onRemove
    }));
  };

  return FormField;
}(_react2.default.Component);

FormField.propTypes = (0, _extends3.default)({}, _fieldProps.FieldProps, {
  onValid: _react2.default.PropTypes.func
});

FormField.contextTypes = {
  form: _react2.default.PropTypes.instanceOf(_formContext.FormContext).isRequired
};

exports.FormField = FormField;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(FormField, 'FormField', 'E:/Projects/React/git/vb-react-form/src/form-field.js');
}();

;